<template>
  <div class="p-2">
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="22"><span>结算等级信息列表</span> </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['customer:settlementLevel:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="selementLevelList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="编号" align="center" prop="settlementLevelId" />
        <el-table-column label="结算等级名称" align="center" prop="settlementLevelName" />
        <el-table-column label="是否显示" align="center" prop="isShow">
          <template #default="scope">
            <el-switch v-model="scope.row.isShow" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:settlementLevel:edit']">编辑</el-button>
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:settlementLevel:remove']"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改结算等级对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="selementLevelFormRef" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="结算等级编码" prop="settlementLevelId">
          <el-input v-model="form.settlementLevelId" placeholder="请输入结算等级编码" />
        </el-form-item>
        <el-form-item label="结算等级名称" prop="settlementLevelName">
          <el-input v-model="form.settlementLevelName" placeholder="请输入结算等级名称" />
        </el-form-item>
        <el-form-item label="是否显示" prop="isShow">
          <el-radio-group v-model="form.isShow">
            <el-radio v-for="dict in sys_platform_yes_no" :key="dict.value" :value="parseInt(dict.value)">{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="SettlementLevel" lang="ts">
import {
  listSettlementLevel,
  getSettlementLevel,
  delSettlementLevel,
  addSettlementLevel,
  updateSettlementLevel,
  changeShowStatus
} from '@/api/customer/settlementLevel';
import { SettlementLevelVO, SettlementLevelQuery, SettlementLevelForm } from '@/api/customer/settlementLevel/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { sys_platform_yes_no } = toRefs<any>(proxy?.useDict('sys_platform_yes_no'));

const selementLevelList = ref<SettlementLevelVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const selementLevelFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: SettlementLevelForm = {
  id: undefined,
  settlementLevelId: undefined,
  settlementLevelName: undefined,
  isShow: '0',
  status: undefined,
  remark: undefined
};
const data = reactive<PageData<SettlementLevelForm, SettlementLevelQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    settlementLevelId: undefined,
    settlementLevelName: undefined,
    isShow: undefined,
    status: undefined,
    platformCode: undefined,
    params: {}
  },
  rules: {
    settlementLevelName: [{ required: true, message: '结算等级名称不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询结算等级列表 */
const getList = async () => {
  loading.value = true;
  const res = await listSettlementLevel(queryParams.value);
  selementLevelList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

const handleStatusChange = async (row: SettlementLevelVO) => {
  const oldValue = row.isShow; // 保存旧值（0 或 1）

  try {
    await changeShowStatus(row.id, row.isShow); // 传新值
    proxy?.$modal.msgSuccess('操作成功');
  } catch {
    row.isShow = oldValue; // 失败回滚
    proxy?.$modal.msgError('操作失败，请重试');
  }
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  selementLevelFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: SettlementLevelVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加结算等级';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: SettlementLevelVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getSettlementLevel(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改结算等级';
};

/** 提交按钮 */
const submitForm = () => {
  selementLevelFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateSettlementLevel(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addSettlementLevel(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: SettlementLevelVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除结算等级编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delSettlementLevel(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'system/settlementLevel/export',
    {
      ...queryParams.value
    },
    `selementLevel_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
